Subject: Re: [patch net-next] cxgb3: update firmware version

From: Ben Hutchings <[email-masked]>
Date: Tue, 14 Feb 2012 22:02:46 +0000

On Tue, Feb 14, 2012 at 12:02:26PM -0800, Rick Jones wrote:
> On 02/14/2012 10:21 AM, Ben Hutchings wrote:
> >On Tue, Feb 14, 2012 at 10:17:27AM -0800, Rick Jones wrote:
> >>What does an end-user/customer see and do?  When they are told that
> >>version the firmware, specified down to the fix level, fixes a
> >>problem they are having, how will they know that firmware blob
> >>filename drvfw-X.bin on a download/archive site has that fix?
> >[...]
> >
> >Customers currently can't get bug fixes by updating the firmware.
> >Think about it.
> 
> Because in this case at least the driver is requesting a specific
> filename down to the minor and micro level and a change in the
> filename requires a change in the driver?
>
> #define FW_VERSION __stringify(FW_VERSION_MAJOR) "."                    \
>         __stringify(FW_VERSION_MINOR) "." __stringify(FW_VERSION_MICRO)
> #define FW_FNAME "cxgb3/t3fw-" FW_VERSION ".bin"
> 
> rather than the driver having logic to make it willing to accept
> later minor/micro changes by being more sophisticated in its
> specification of firmware file.
 
Well, you can't really be very sophisticated as there is no way to
list the available firmware files.

The Intel wireless drivers try iterating from the newest to oldest
supported API version.  But that API version is changed only rarely.
If you were to iterate over some wide range of potential future
versions it could take a substantial time to find the file that's
actualy installed.

Ben.

-- 
Ben Hutchings
We get into the habit of living before acquiring the habit of thinking.
                                                              - Albert Camus